function [weig_g, f] = g_func(z,r)

[n,k] = size(z);

%transform z into unit interval
z = normcdf((z-kron(ones(n,1),mean(z)))./kron(ones(n,1),std(z)));

%number of weight functions
r2 = (2:2:2*r)';
n_g = (sum(r2))*k;

%weight function
weig = 1./(((r2./2 + 100).^2).*(k*r2));

%construct g functions: indicators
i = 1;
f = zeros(n,n_g);
weig_g = zeros(n_g,1);
for i1 = 1:k
    for r1 = 1:r
        for a1 = 1:2*r1
            ind_temp = (z(:,i1)>=(a1-1)/(2*r1))&(z(:,i1)<=a1/(2*r1));
            f(:,i) = ind_temp;
            weig_g(i,1) = weig(r1);
            i = i+1;
        end
    end
end
f = sparse(f);
%remove zero columns
%f_zero_ind = sum(f) == 0;
%f(:,f_zero_ind) = [];
%weig_g(f_zero_ind') = [];